#version 120

varying vec4 starData; //rgb = star color, a = flag for weather or not this pixel is a star.

const float PI = 3.1415927;

varying vec2 lmcoord;
varying vec2 texcoord;
varying vec4 glcolor;
varying vec3 normal;
varying vec3 shadowLightPosition;
// Uniforms
varying vec3 cameraPosition;
uniform float frameTimeCounter;
uniform mat4 gbufferModelView;
uniform mat4 gbufferModelViewInverse;

void main() {
	normal = normalize(gl_NormalMatrix * gl_Normal);
	gl_Position = ftransform();
	vec4 position = gbufferModelViewInverse * gl_ModelViewMatrix * gl_Vertex;
	vec3 worldpos = position.xyz + cameraPosition;
	// Calculate wave
	float wave = 1*sin(2 * PI * (frameTimeCounter*0.7 + worldpos.x * 0.14 + worldpos.z * 0.07))
			+ 1*sin(2 * PI * (frameTimeCounter*0.5 + worldpos.x * 0.10 + worldpos.z * 0.20));
	position.y = wave * 0.5 + position.y;
	gl_Position = gl_ProjectionMatrix * gbufferModelView * position;
	starData = vec4(gl_Color.rgb, float(gl_Color.r == gl_Color.g && gl_Color.g == gl_Color.b && gl_Color.r > 0.0));
}
